Mission = {}

Mission.pilot = 'Enfield 1-1' --name of player/client heli unit
Mission.truck = GROUP:FindByName('Truck')
Mission.fuelTruck = GROUP:FindByName('FuelTruck'):SetAIOff()
Mission.transport_trucks = GROUP:FindByName('Transports'):SetAIOff()
Mission.StartTimer = 5 -- Start Mission after # of sec
Mission.SafeZone = ZONE:New('SafeZone')
Mission.LandingZone = ZONE:New('LandingZone')
Mission.CargoSet = SET_CARGO:New():FilterPrefixes('Troops'):FilterStart()

Mission.DropOffTroops = false
Mission.LZ_Smoke = false
Mission.Complete = false
troopCargo = ""

--Functions
--USERSOUND:New( 'CarHorn.ogg' ):ToGroup(GROUP:FindByName(pilot))
--GROUP:FindByName("Troops"):Activate(6)
function Mission.TroopTruckArrived()
  USERSOUND:New( 'CarHorn.ogg' ):ToAll()
  GROUP:FindByName("Troops"):Activate(10)
  SCHEDULER:New( nil, function() 
    MESSAGE:New('Your troops have arrived and will board shortly...',5):ToAll()
  end, {}, 10)
  
  --board troops into helo
  SCHEDULER:New( nil, function() 
    USERSOUND:New( "MountUp.ogg" ):ToAll()
    MESSAGE:New('Alright ladies, Mount Up!',5):ToAll()
    troopCargo = CARGO_GROUP:New( GROUP:FindByName("Troops"), "Troops", "Troops", 14 )
    troopCargo:__Board(4, GROUP:FindByName(Mission.pilot), 14 )
    
  end, {}, 20)
  
  smokelzsch = SCHEDULER:New( nil, function()
  
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.LandingZone) and Mission.LZ_Smoke == false then
       Mission.LZ_Smoke = true
       USERSOUND:New( "chirp.ogg" ):ToAll()
       MESSAGE:New('We can hear you near by - poping orange smoke...',5):ToAll()
       --smoke truck
       UNIT:FindByName('Truck-1-2'):SmokeOrange()
       smokelzsch:Stop()
    end 
    
  end, {}, 60,2)
  
end

Mission.SafeZoneAlert = false
safeZoneAlert = SCHEDULER:New( nil, function() 
  if GROUP:FindByName(Mission.pilot):IsInZone(Mission.SafeZone) == false and Mission.SafeZoneAlert == false then
    Mission.SafeZoneAlert = true
    USERSOUND:New( "radioscratch.ogg" ):ToAll()
    MESSAGE:New('You are entering into enemy territory',8,'HQ'):ToAll()
    safeZoneAlert:Stop()
  end
end, {}, 15,5)


--EVENTS
Mission.EventHandler = EVENTHANDLER:New()
Mission.EventHandler:HandleEvent( EVENTS.Birth )
Mission.EventHandler:HandleEvent(EVENTS.Takeoff)
Mission.EventHandler:HandleEvent(EVENTS.Land)

--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 

function Mission.EventHandler:OnEventBirth( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
  if PlayerUnit:GetName() == Mission.pilot then
    SCHEDULER:New( nil, function() 
      USERSOUND:New( 'TheFraternityIntro.ogg' ):ToAll()
      MESSAGE:New('Welcome to The Fraternity...',10):ToAll()
      
        SCHEDULER:New( nil, function() 
          USERSOUND:New( 'radioscratch.ogg' ):ToAll()
          MESSAGE:New('Our troops will arrive shortly - lets begin startup procedures.',7,'Co Pilot'):ToAll()
        end, {}, 15)
      
    end, {}, 3)

    --start trucks / activate mission
    SCHEDULER:New( nil, function() 
      Mission.fuelTruck:SetAIOn() 
      Mission.truck:Activate()
    end, {}, Mission.StartTimer)
  end
end


function Mission.EventHandler:OnEventLand( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
  if GROUP:FindByName(Mission.pilot):IsInZone(Mission.LandingZone) and Mission.DropOffTroops == false then

    Mission.DropOffTroops = true
    troopCargo:__UnBoard(2, UNIT:FindByName('Truck-1-1'):GetPointVec2())
      SCHEDULER:New( nil, function() 
        --destroy cargo, activate trucks
        troopCargo:Destroy()
        Mission.transport_trucks:SetAIOn()
      end, {}, 25)
  end
  
  --check if landing back home - ending mission
  if GROUP:FindByName(Mission.pilot):IsInZone(Mission.SafeZone) and Mission.DropOffTroops == true and Mission.Complete == false then
     Mission.Complete = true
     --mission successful
     SCHEDULER:New( nil, function() 
      USERSOUND:New( "chirp.ogg" ):ToAll()
      MESSAGE:New('Excellent work, mission successful.',10,'HQ'):ToAll()
    end, {}, 5)
  end
  
end
    